(*
-------------------------------------------------------------------------------
-- Name of the source		: Archive.t
-- Author(s)			: Jose Luis Albero
-- Date of creation		: 8/7/93
-- Defined Objects		: Archive
-- Description of the contents	: Generic object to make an object persistent.
-- Document reference		: 
-- Copyright 1993, TAO S.A., Barcelona, Spain
-- This software was produced as part of the ESPRIT project ITHACA-IT.
-------------------------------------------------------------------------------
-- Modification log	:
-- Version	Date	Author	Description
-- ---------- --------- ------- -----------------------------------------------
-------------------------------------------------------------------------------
*)

SPECIFICATION Archive 

IMPORT Stream FROM Stream;  --FileStream object

TYPE Archive = OBJECT (IN inMode : CHAR, IN inName : STRING)

--Generic non-instantiable object. Subtypes of Archive provide a means to
--archive object contents into data streams. This way object state's can be
--made persistent. 

PUBLIC
METHOD Close ();

PROTECTED
STATE
stStream : Stream;

END OBJECT; -- Archive


END SPECIFICATION;
