(*
-------------------------------------------------------------------------------
-- Name of the source		: CalendarArch.t
-- Author(s)			: Jose Luis Albero
-- Date of creation		: 8/7/93
-- Defined Objects		: CalendarArch
-- Description of the contents	: Object to make a calendar persistent
-- Document reference		: 
-- Copyright 1993, TAO S.A., Barcelona, Spain
-- This software was produced as part of the ESPRIT project ITHACA-IT.
-------------------------------------------------------------------------------
-- Modification log	:
-- Version	Date	Author	Description
-- ---------- --------- ------- -----------------------------------------------
-------------------------------------------------------------------------------
*)

SPECIFICATION CalendarArch 

IMPORT Archive FROM Archive;  --Archive object
IMPORT Calendar FROM Calendar; --Calendar object

TYPE CalendarArch = Archive OBJECT (IN inMode : CHAR, IN inName : STRING)
PUBLIC
  METHOD StoreCalendar (IN inCalendar : Calendar);
  METHOD LoadCalendar () : Calendar;

PROTECTED
STATE -- CalendarArch

END OBJECT; -- CalendarArch

END SPECIFICATION;
