(*
-------------------------------------------------------------------------------
-- Name of the source		: TimeStamp.t
-- Author(s)			: SNI
-- Date of creation		: 10 Feb 1992
-- Defined Objects		: TimeStamp
-- Description of the contents	: 
-- Document reference		: 
-- Copyright 1993, TAO S.A., Barcelona, Spain
-- This software was produced as part of the ESPRIT project ITHACA-IT.
-------------------------------------------------------------------------------
-- Modification log	:
-- Version	Date	Author	Description
-- ----------- -------- ------- -----------------------------------------------
--             21/04/93 JLA     Modification of the Methods Add and Subtract
--                              (both related with Duration). There is a new
--                              method: NDistance.
-------------------------------------------------------------------------------
*)

SPECIFICATION TimeSt 

IMPORT Date FROM Date; --Date object
IMPORT Time FROM Time; --Time object

TYPE TimeStamp = Date OBJECT (IN inYear : INT, IN inMonth : INT,
                              IN inDay : INT, IN inStamp : Time)

PUBLIC
  METHOD GetTime () : Time;
    -- Returns the specific information of the current date.
  METHOD SetTime (IN inStamp : Time);
    -- Sets the values of the current date.

PROTECTED
STATE -- TimeStamp
  time : Time;

END OBJECT; -- TimeStamp

END SPECIFICATION;
