.OH "'CooL Language Reference Manual''Windows NT Specific Extensions'"
.EH "'Windows NT Specific Extensions''CooL Language Reference Manual'"
.bp
.NX 1 "Windows NT Specific Extensions"
.LP
The following language extensions are necessary to support the
development of graphical applications on a Windows NT system.
For compatibility reasons, these extensions are supported on an SINIX
system too, but it is not recommened to use them there.
.LP
.\"===========================================================================
.NX 2 "Import Foreign".LP
A import foreign clause has the form
.Ss
IMPORT FOREIGN "file.h";
.Se
where 
.Si file.h
is the name of a C-header file.
.LP
The C-header file
.Si file.h
is included in the generated code.
.\"===========================================================================
.NX 2 "Foreign Types"
.LP
The specification of a foreign type has the form
.Ss
FOREIGN TYPE I = T;
.Se
where
.Si I
is an identifier and
.Si T
is a type. It declares
.Si I
as a type names which is equivalent to
.Si T.
The definition of the type
.Si I
must be included in the generated code using a import
foreign clause (see section \f27.1 Import Foreign\fP).
.\"===========================================================================
.NX 2 "Calling Convention"
.LP
Some routines of the Windows NT system are specified with an special
function attribute
.Si (__stdcall)
to controll the calling convention. This this is an Microsoft-specific
extension of the language C.
.LP
The specification of a foreign procedure with this special calling
convention has the form:
.Ss
FOREIGN PASCAL P;
.Se
where
.Si P
is an procedure specification.
.LP
The specification of a CooL procedure which should be used as an
Windows callback routine has the form:
.Ss
EXPORT FOREIGN PASCAL P;
.Se
where
.Si P
is an procedure specification.
.LP
If the special calling convention is required for the start routine of
the programm, the root declartion has the following form:
.Ss
ROOT PASCAL P;
.Se
where
.Si P
is an procedure specification.
.LP
For compatibility reasons, the keyword
.Si PASCAL
has no effect on a SINIX system.
