--                             -*- Mode: Cool2 -*- 
-- error.cs -- 
-- 
--   Copyright (C) SieTec Systemtechnik GmbH & Co OHG 1993
--   All rights reserved
-- 
-- AtFSID          : $Header: error.cs[1.0] Tue Feb 22 09:59:35 1994 lutz@hawaii saved $
-- Author          : Lutz Hilken
-- 
-- Created On      : Thu Jan 27 09:48:45 1994
-- Last Modified By: Lutz Hilken
-- Last Modified On: Tue Mar 22 14:33:59 1994
-- Update Count    : 9
-- 
-- HISTORY
-- PURPOSE
-- 	|>Description of module's purpose<|
-- 

SPECIFICATION error

IMPORT FILE FROM Basics;

PROCEDURE GetOutputFile () : REF FILE;

FOREIGN PROCEDURE Trace   (IN msg : ARRAY OF CHAR, ..);
FOREIGN PROCEDURE Message (IN msg : ARRAY OF CHAR, ..);

CONST HELP_ERROR                     : INT =  0;
CONST ILLEGAL_COMMAND_SYNTAX   	     : INT =  1;
CONST ILLEGAL_INDEX	       	     : INT =  2;
CONST INDEX_NOT_AN_INT         	     : INT =  3;
CONST INTERRUPT                	     : INT =  4;
CONST MAX_IMPLEMENTATION       	     : INT =  5;
CONST MAX_LONG_VERSION         	     : INT =  6;
CONST MAX_SHORT_VERSION        	     : INT =  7;
CONST MAX_WARNING              	     : INT =  8;
CONST NOT_AN_ARRAY	       	     : INT =  9;
CONST NOT_A_REFERENCE          	     : INT = 10;
CONST NOT_A_STRUCTURE	       	     : INT = 11;
CONST NO_ACTIVE_PROCESS        	     : INT = 12;
CONST NO_ACTIVE_ROUTINE        	     : INT = 13;
CONST NO_PARAM_EXPECTED	       	     : INT = 14;
CONST OBJECT_NOT_INITIALIZED   	     : INT = 15;
CONST ONE_PARAM_EXPECTED       	     : INT = 16;
CONST OPEN_PIPE_ERROR	       	     : INT = 17;
CONST PROCESS_DIED             	     : INT = 18;
CONST SYNTAX_ERROR	       	     : INT = 19;
CONST TOO_MANY_COLONS	       	     : INT = 20;
CONST TOO_MANY_DIMS	       	     : INT = 21;
CONST TOO_MANY_DOTS	       	     : INT = 22;
CONST UNKNOWN_ADDRESS          	     : INT = 23;
CONST UNKNOWN_ATTRIBUTE        	     : INT = 24;
CONST UNKNOWN_COMPONENT	       	     : INT = 25;
CONST UNKNOWN_FILE	       	     : INT = 26;
CONST UNKNOWN_FILE_OR_FUNCTION 	     : INT = 27;
CONST UNKNOWN_FUNCTION         	     : INT = 28;
CONST UNKNOWN_FUNCTION_OR_OBJECTTYPE : INT = 29;
CONST UNKNOWN_METHOD           	     : INT = 30;
CONST UNKNOWN_OBJECTTYPE       	     : INT = 31;
CONST UNKNOWN_OBJECTTYPES      	     : INT = 32;
CONST UNKNOWN_TYPE   	       	     : INT = 33;
CONST UNKNOWN_VARIABLE	       	     : INT = 34;

PROCEDURE Error (IN number : INT, 
		 IN additional_string : ARRAY OF CHAR);

END SPECIFICATION;

